//-----------------------------------------------------------------------------
// boost mpl/void.hpp header file
// See http://www.boost.org for updates, documentation, and revision history.
//-----------------------------------------------------------------------------
//
// Copyright (c) 2001-02
// Peter Dimov, Aleksey Gurtovoy
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee, 
// provided that the above copyright notice appears in all copies and 
// that both the copyright notice and this permission notice appear in 
// supporting documentation. No representations are made about the 
// suitability of this software for any purpose. It is provided "as is" 
// without express or implied warranty.

#ifndef BOOST_MPL_VOID_HPP_INCLUDED
#define BOOST_MPL_VOID_HPP_INCLUDED

#include "boost/mpl/bool_c.hpp"
#include "boost/config.hpp"

namespace boost {
namespace mpl {

struct void_;

template< typename T >
struct is_void_
    : false_c
{
#if defined(BOOST_MSVC) && BOOST_MSVC < 1300
    using false_c::value;
#endif
};

template<>
struct is_void_<void_>
    : true_c
{
#if defined(BOOST_MSVC) && BOOST_MSVC < 1300
    using true_c::value;
#endif
};

} // namespace mpl
} // namespace boost

#endif // BOOST_MPL_VOID_HPP_INCLUDED
